package br.ufes.inf.prog3.lista1;

/**
 * Programa que calcula o máximo divisor comum entre 2 números passados como argumentos. Utiliza a definição de MDC do exercício 3 da lista 1.
 *
 * @author Vitor E. Silva Souza (vitorsouza@gmail.com)
 * @version 1.0
 */
public class Exercicio03 {
	/** Método principal. */
	public static void main(String[] args) {
		// Verifica se foram passados 2 argumentos.
		if (args.length != 2) {
			System.out.println("Este programa deve ser executado com 2 argumentos numéricos.");
			System.exit(1);
		}
		
		// Converte os argumentos para números inteiros.
		int x = Integer.parseInt(args[0]);
		int y = Integer.parseInt(args[1]);
		
		// Prepara o resultado.
		String result = "MDC(" + x + ", " + y + ") = ";
		
		// Caso trivial: MDC(x,x) = x.
		while (x != y) {
			// Caso 1: se x > y, MDC(x, y) = MDC(x-y, y).
			if (x > y)
				x = x - y;
			
			// Caso 2: MDC(x, y) = MDC(y, x).
			else {
				int tmp = x;
				x = y;
				y = tmp;
			}
		}
		
		// Imprime o resultado.
		result += x;
		System.out.println(result);
	}
}
