package br.ufes.inf.prog3.lista1;

import java.util.Scanner;

/**
 * Programa que manipula um vetor de 10 números inteiros positivos como descrito no exercício 4 da lista 1.
 * 
 * @author Vitor E. Silva Souza (vitorsouza@gmail.com)
 * @version 1.0
 */
public class Exercicio04 {
	/** Constante que determina o tamanho do vetor. */
	private static final int TAMANHO_VETOR = 10;
	
	/** Método principal. */
	public static void main(String[] args) {
		int[] vetor = new int[10];
		int x = 0;
		
		// Lê os números do vetor.
		Scanner scanner = new Scanner(System.in);
		System.out.println("Digite " + TAMANHO_VETOR + " números inteiros positivos separados por espaço ou Enter.");
		for (int i = 0; i < vetor.length; i++)
			vetor[i] = scanner.nextInt();
		
		// Lê o número x.
		System.out.println("Digite um número inteiro positivo x.");
		x = scanner.nextInt();
		scanner.close();
		
		// Prepara as variáveis para a verificação dos itens (c), (d) e (e) do enunciado da questão.
		int maiorDistancia = vetor[1] - vetor[0];
		int indiceMaiorDistancia = 1;
		boolean crescente = true, decrescente = true;
		int maioresX = 0, menoresX = 0, iguaisX = 0;
		
		// Com relação ao quesito (e), processa o primeiro item do vetor separadamente.
		if (vetor[0] > x)
			maioresX++;
		else if (vetor[0] == x)
			iguaisX++;
		else
			menoresX++;
		
		// Passa pelo vetor para verificar os itens (c), (d) e (e) do enunciado da questão.
		for (int i = 1; i < vetor.length; i++) {
			// Verifica item (c): o par com maior distância.
			int distancia = vetor[i] - vetor[i - 1];
			if (distancia > maiorDistancia) {
				maiorDistancia = distancia;
				indiceMaiorDistancia = i;
			}
			
			// Verifica o item (d): ordem do vetor.
			if (vetor[i] >= vetor[i - 1])
				decrescente = false;
			if (vetor[i] <= vetor[i - 1])
				crescente = false;
			
			// Verifica o item (e): quantidade de maiores, menores e iguais a X.
			if (vetor[i] > x)
				maioresX++;
			else if (vetor[i] == x)
				iguaisX++;
			else
				menoresX++;
		}
		
		// Imprime os resultados.
		System.out.printf("(c) A maior distância é de %d, entre os elementos vetor[%d] = %d e vetor[%d] = %d%n", maiorDistancia, indiceMaiorDistancia - 1, vetor[indiceMaiorDistancia - 1], indiceMaiorDistancia, vetor[indiceMaiorDistancia]);
		System.out.printf("(d) A ordem do vetor é: %s%n", (crescente ? "crescente" : (decrescente ? "decrescente" : "não ordenado")));
		System.out.printf("(e) Dado x = %d, no vetor existem %d elemento(s) maior(es) que x, %d elemento(s) menor(es) que x e %d elemento(s) igual(is) a x.%n", x, maioresX, menoresX, iguaisX);
	}
}
